#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glaux.h>
#include <stdio.h>

#define R_NM3_ITSELF

#include "r_nm3.h"

union ufloat{
  float Float;
  int Int;
};

float nm3_swapF(float f){
  short a = 1;
  ufloat uf1, uf2;
  uf1.Float = f;
  int i = 0;
  if(*(char *)&a == 1){
    i += (uf1.Int >> 24) & 0x000000FF;
    i += (uf1.Int >> 8) & 0x0000FF00;
    i += (uf1.Int << 8) & 0x00FF0000;
    i += (uf1.Int << 24) & 0xFF000000;
    uf2.Int = i;
    return uf2.Float;
  }
  else{
    return f;
  }
}

int nm3_swapW(int w){
  short a = 1;
  int n = 0;
  if(*(char *)&a == 1){
    n += (w >> 24) & 0x000000FF;
    n += (w >> 8) & 0x0000FF00;
    n += (w << 8) & 0x00FF0000;
    n += (w << 24) & 0xFF000000;
    return n;
  }
  else{
    return w;
  }
}

nm3dst *read_nm3(char *file_name){
  int i, j;
  int v;
  int f;
  float *d_v;
  int *d_f;
  float *d_n;
  nm3dst *n3;
  FILE *fp;

  if((fp = fopen(file_name, "rb")) == NULL){
    return NULL;
  }

  fread(&v, sizeof(int), 1, fp);
  fread(&f, sizeof(int), 1, fp);

  v = nm3_swapW(v);
  f = nm3_swapW(f);

  if((d_v = (float *)malloc(sizeof(float) * v * 3)) == NULL){
    fclose(fp);
    return NULL;
  }

  if((d_f = (int *)malloc(sizeof(int) * f * 3)) == NULL){
    fclose(fp);
    return NULL;
  }

  if((d_n = (float *)malloc(sizeof(float) * f * 3)) == NULL){
    fclose(fp);
    return NULL;
  }

  // _f[^ǂݍ
  for (i = 0; i < v; i++) {
    for(j = 0; j < 3; j++){
      float f;
      fread(&f, sizeof(float), 1, fp);
      d_v[i * 3 + j] = nm3_swapF(f);
    }
  }

  // ʃf[^ǂݍ
  for (i = 0; i < f; i++) {
    for(j = 0; j < 3; j++){
      int f;
      fread(&f, sizeof(int), 1, fp);
      d_f[i * 3 + j] = nm3_swapW(f);
    }
  }

  // @f[^ǂݍ
  for (i = 0; i < f; i++) {
    for(j = 0; j < 3; j++){
      float f;
      fread(&f, sizeof(float), 1, fp);
      d_n[i * 3 + j] = nm3_swapF(f);
    }
  }

  if((n3 = (nm3dst *)malloc(sizeof(nm3dst))) == NULL){
    fclose(fp);
    return NULL;
  }

  n3->vertex = v;
  n3->face = f;
  n3->data_vertex = (GLfloat *)d_v;
  n3->data_face = (int *)d_f;
  n3->data_normal = (GLfloat *)d_n;

  fclose(fp);
  
  return n3;
}

void free_nm3(nm3dst *n3){
  free(n3->data_vertex);
  free(n3->data_face);
  free(n3->data_normal);
  free(n3);
}
