#include <windows.h>
#include <GL/gl.h>
#include <stdio.h>

#define R_NMT_ITSELF

#include "r_nmt.h"

/*
*  GfBA΍ [hl̃Xbv
*/
int nmt_swapW(int w){
  short a = 1;
  int n = 0;
  if(*(char *)&a == 1){
    n += (w >> 24) & 0x000000FF;
    n += (w >> 8) & 0x0000FF00;
    n += (w << 8) & 0x00FF0000;
    n += (w << 24) & 0xFF000000;
    return n;
  }
  else{
    return w;
  }
}

/*
*   r_nmt.h Œ` nmtxst \̂ɁA
*   malloc ł̗̈܂߉摜t@C̃f[^ǂݍ
*   Ȃ nmtxst \̂̐擪|C^ sȂNULL Ԃ
*/
nmtxst *read_nmt(char *file_name){
  int i, j;
  int w;
  int h;
  char *d_rgb;
  nmtxst *nmt;
  FILE *fp;

  if((fp = fopen(file_name, "rb")) == NULL){
    return NULL;
  }

  // 摜̍ÃsNZ𓾂
  fread(&w, sizeof(int), 1, fp);
  fread(&h, sizeof(int), 1, fp);

  w = nmt_swapW(w);
  h = nmt_swapW(h);

  // rgb f[^̈ malloc Ŋm
  if((d_rgb = (char *)malloc(sizeof(char) * w * h * 3)) == NULL){
    fclose(fp);
    return NULL;
  }

  // rgb f[^ǂݍ
  for (i = 0; i < w * h; i++) {
    for(j = 0; j < 3; j++){
      unsigned char uc;
      fread(&uc, sizeof(char), 1, fp);
      d_rgb[i * 3 + j] = uc;
    }
  }

  // nmtxst \̗̈ malloc Ŋm
  if((nmt = (nmtxst *)malloc(sizeof(nmtxst))) == NULL){
    free(d_rgb);
    fclose(fp);
    return NULL;
  }

  nmt->width = w;
  nmt->height = h;
  nmt->data_rgb = (GLubyte *)d_rgb;
  
  fclose(fp);

  return nmt;
}

/*
*  nmtxst \̂̃f[^
*/
void free_nmt(nmtxst *nmt){
  if(nmt != NULL){ 
    if(nmt->data_rgb != NULL){
      free(nmt->data_rgb);
      nmt->data_rgb = NULL;
    }
    free(nmt);
  }
}