#include <windows.h>
#include <GL/gl.h>
#include "ss_card.h"

#define SS_ATARI_ITSELF

#include "ss_atari.h"

/*
*    (bx1, by1)-(bx2, by2)  y = ay ̌_Ԃ
*   _ꍇ -1 Ԃ
*/
int cross_point(int ay, int bx1, int by1, int bx2, int by2){
  double x1, y1, x2, y2;
  double fx, fy;
  int cx;
  
  /* xW */
  if((ay - by1 > 0 && ay - by2 > 0) || (ay - by1 < 0 && ay - by2 < 0)){
    return -1;
  }
  
  if(by1 - ay == 0){
    cx = bx1;
  }
  else if(by2 - ay == 0){
    cx = bx2;
  }
  else{
    x1 = (double)bx1;
    y1 = (double)by1;
    x2 = (double)bx2;
    y2 = (double)by2;
  
    fy = (double)ay;
  
    fx = (fy - y1) * (x2 - x1) / (y2 - y1) + x1;
    
    cx = (int)fx;
  }
  
  if(cx < 0)cx = 0;
  
  return cx;
}

/*
*   _ (x, y) Op` ABC ̓ɂ邩H
*    1 A 0 Ԃ
*   (F̍WɂΉĂȂ)
*/
int in_triangle(int x, int y, int ax, int ay, int bx, int by, int cx, int cy){
  int cp1, cp2, cp3;

  cp1 = cross_point(y, ax, ay, bx, by);
  cp2 = cross_point(y, bx, by, cx, cy);
  cp3 = cross_point(y, cx, cy, ax, ay);
  
  /* _O */
  if(cp1 < 0 && cp2 < 0 && cp3 < 0){
    return 0;
  }
  
  /* _P */
  if(cp1 - cp2 == 0 && cp3 < 0){
    return 0;
  }
  if(cp1 - cp3 == 0 && cp2 < 0){
    return 0;
  }
  if(cp2 - cp3 == 0 && cp1 < 0){
    return 0;
  }
  
  /* _Q */
  if(cp1 - cp2 == 0){
    cp2 = -1;
  }
  else if(cp1 - cp3 == 0 || cp2 - cp3 == 0){
    cp3 = -1;
  }

  if((cp1 - x) * (cp2 - x) * (cp3 - x) >= 0){
    return 1;
  }
  
  return 0;
}

/*
*   Rc̍WQc̉ʂ̍Wɒu
*/
void from3Dto2D(float x, float y, float z, int *px, int *py){
  int ix, iy;
  float fx, fy;
  
  fx = -x / z * 2.0f + 1.4f;
  fy = y / z * 2.0f + 1.0f;
  
  ix = (int)((float)screenwidth * fx / 2.8f);
  iy = (int)((float)screenheight * fy / 2.0f);
  
  *px = ix;
  *py = iy;
}

/*
*   ŏI\Ԃł̊eJ[ĥS_Zo
*/
void set_atari(int num){
  float ax, ay, az;
  float bx, by, bz;
  float cx, cy, cz;
  float dx, dy, dz;
  int x1, y1, x2, y2, x3, y3, x4, y4;
  
  if(v_flag == 0){
    return;
  }
  
  ax = CARD_AX * v[num][0] + CARD_AY * v[num][4] + CARD_AZ * v[num][8] + v[num][12];
  ay = CARD_AX * v[num][1] + CARD_AY * v[num][5] + CARD_AZ * v[num][9] + v[num][13];
  az = CARD_AX * v[num][2] + CARD_AY * v[num][6] + CARD_AZ * v[num][10] + v[num][14];
  
  bx = CARD_BX * v[num][0] + CARD_BY * v[num][4] + CARD_BZ * v[num][8] + v[num][12];
  by = CARD_BX * v[num][1] + CARD_BY * v[num][5] + CARD_BZ * v[num][9] + v[num][13];
  bz = CARD_BX * v[num][2] + CARD_BY * v[num][6] + CARD_BZ * v[num][10] + v[num][14];
  
  cx = CARD_CX * v[num][0] + CARD_CY * v[num][4] + CARD_CZ * v[num][8] + v[num][12];
  cy = CARD_CX * v[num][1] + CARD_CY * v[num][5] + CARD_CZ * v[num][9] + v[num][13];
  cz = CARD_CX * v[num][2] + CARD_CY * v[num][6] + CARD_CZ * v[num][10] + v[num][14];
  
  dx = CARD_DX * v[num][0] + CARD_DY * v[num][4] + CARD_DZ * v[num][8] + v[num][12];
  dy = CARD_DX * v[num][1] + CARD_DY * v[num][5] + CARD_DZ * v[num][9] + v[num][13];
  dz = CARD_DX * v[num][2] + CARD_DY * v[num][6] + CARD_DZ * v[num][10] + v[num][14];
  
  from3Dto2D(ax, ay, az, &x1, &y1);
  from3Dto2D(bx, by, bz, &x2, &y2);
  from3Dto2D(cx, cy, cz, &x3, &y3);
  from3Dto2D(dx, dy, dz, &x4, &y4);
  
  v2[num][0][0] = x1;
  v2[num][0][1] = y1;
  v2[num][1][0] = x2;
  v2[num][1][1] = y2;
  v2[num][2][0] = x3;
  v2[num][2][1] = y3;
  v2[num][3][0] = x4;
  v2[num][3][1] = y4;
}

/*
*   eJ[h̕ϊsۑ
*/
void setV(int num, GLfloat *pv){
  int i;
  
  for(i = 0; i < 16; i++){
    v[num][i] = pv[i];
  }
  
  v_flag = 1;
  
  set_atari(num);
}

/*
*   (x, y) ̈ʒuɃJ[h num  1 Ԃ
*/
int atari_card(int x, int y, int num){
  if(in_triangle(x, y, v2[num][0][0], v2[num][0][1], v2[num][1][0], v2[num][1][1], v2[num][2][0], v2[num][2][1])){
    return 1;
  }
  
  if(in_triangle(x, y, v2[num][0][0], v2[num][0][1], v2[num][2][0], v2[num][2][1], v2[num][3][0], v2[num][3][1])){
    return 1;
  }
  
  return 0;
}

/*
*   (x, y) ̈ʒũJ[h index Ԃ
*/
int atariCard(int x, int y, int num){
  int i;

  for(i = 0; i < num; i++){
    if(atari_card(x, y, i)){
      return i;
    }
  }
  
  return -1;
}

/*
*   eJ[h̕ϊs擾
*/
GLfloat *getV(int num){
  return v[num];
}

/*
*  getV  atari_card gp\ɂ
*  sw sh ͉ʃTCY row col ̓J[husA
*/
void change_v(int sw, int sh, int row, int col){
  int i, j;

  if(sw <= 0 || sh <= 0){
    return;
  }

  screenwidth = sw;
  screenheight = sh;
  
  if(row > 0 && col > 0){
    float shift_dx, shift_dy;
    GLfloat v[16];
    
    shift_dx = 0.175f * (8 - col);
    shift_dy = 0.4f * (8 - row);
  
    // J[hʒuւ̕ϊs̋L^
    for(j = 0; j < row; j++){
      for(i = 0; i < col; i++){
        glLoadIdentity();

        glTranslated(-1.4, -1.0, -2.0);

        glRotated(45.0, 1.0, 0.0, 0.0);
      
        glTranslated(0.0, 0.0, -4.0);
      
        glTranslated(0.175 + 0.35 * (float)i + shift_dx, 0.0, 0.25 + 0.5 * (float)j + shift_dy);

        glGetFloatv(GL_MODELVIEW_MATRIX, v);
      
        setV(j * col + i, v);
      }
    }
  }
}
