#include <windows.h>
#include <GL/gl.h>
#include "ss_table.h"
#include "ss_state.h"
#include "nmTexture.h"

#define SS_CARD_ITSELF

#include "ss_card.h"

/*
*   J[hԂ
*/
int initCard(int num){
  int i, result = 1;

  g_card = num;

  result &= initTable(num);
  result &= initState(num);

  for(i = 0; i < num; i++){
    state_rotate[i] = 0.0f;
    state_visible[i] = 1;
  }

  if(!result){
    return 0;
  }

  return 1;
}

/*
*   J[hJ
*/
int openCard(int index){
  setState(index, STATE_OPEN);

  return 1;
}

/*
*   J[h̔ԍ𓾂
*/
int getCardNum(int index){
  int num;

  getTableNumber(index, &num);

  return ((num - 1) >> 1);
}

/*
*   J[h̏Ԃ𓾂
*/
int getCardState(int index){
  int state;

  getState(index, &state);

  return state;
}

/*
*   ĂJ[h烉_őI
*/
int getRandomCard(){
  int index;

  getRandomIndex(STATE_CLOSE, &index);

  return index;
}

/*
*   J[h
*/
int takeCard(int index){
  setState(index, STATE_SPACE);

  return 1;
}

/*
*   J[h
*/
int closeCard(int index){
  setState(index, STATE_CLOSE);

  return 1;
}

/*
*   J[ȟЕt
*/
void deinitCard(){
  deinitTable();
  deinitState();
}

/*
*   [vł̏
*/
void loopCard(){
  int i;
  int state;
  for(i = 0; i < g_card; i++){
    getState(i, &state);
    if(state == STATE_OPEN){
      if(state_rotate[i] > -180.0f){
        state_rotate[i] -= 60.0f;
      }
    }
    else if(state == STATE_SPACE){
      state_visible[i] = 0;
    }
    else if(state == STATE_CLOSE){
      if(state_rotate[i] < 0.0f){
        state_rotate[i] += 60.0f;
      }
    }
  }
}

/*
*   `揈
*/
void paintCard(int index, int num){

  if(!state_visible[index])return;

  glRotated(state_rotate[index], 0.0, 0.0, 1.0);

  glDisable(GL_CULL_FACE);
  
  glColor3d(1.0, 1.0, 1.0);

  glBegin(GL_QUADS);

  // 
  glVertex3f(CARD_AX, CARD_AY, CARD_AZ + FUTI);
  glVertex3f(CARD_BX , CARD_BY, CARD_BZ - FUTI);
  glVertex3f(CARD_BX + FUTI, CARD_CY, CARD_CZ - FUTI);
  glVertex3f(CARD_AX + FUTI, CARD_DY, CARD_DZ + FUTI);

  // 
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_BZ - FUTI);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_BZ);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_CZ);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_CZ - FUTI);

  // E
  glVertex3f(CARD_DX - FUTI, CARD_AY, CARD_AZ + FUTI);
  glVertex3f(CARD_CX - FUTI, CARD_BY, CARD_BZ - FUTI);
  glVertex3f(CARD_CX, CARD_CY, CARD_CZ - FUTI);
  glVertex3f(CARD_DX, CARD_DY, CARD_DZ + FUTI);
  
  // 㕣
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_AZ);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_AZ + FUTI);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_DZ + FUTI);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_DZ);
  
  glEnd();

  // 㕣
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_AZ + FUTI);
  glVertex3f(CARD_AX, CARD_AY, CARD_AZ + FUTI);
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_AZ);
  glEnd();

  // 
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_BZ - FUTI);
  glVertex3f(CARD_BX, CARD_BY, CARD_BZ - FUTI);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_BZ);
  glEnd();
  
  // E
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_CZ - FUTI);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_CZ);
  glVertex3f(CARD_CX, CARD_CY, CARD_CZ - FUTI);
  glEnd();
  
  // E㕣
  glBegin(GL_TRIANGLE_FAN);
  glVertex3f(CARD_DX, CARD_DY, CARD_DZ + FUTI);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_DZ);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_DZ + FUTI);
  glEnd();

  glEnable(GL_CULL_FACE);

  glEnable(GL_TEXTURE_2D);
  
  setTexture(CARDURA_TEX_INDEX);

  // Gij
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.95f);
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_AZ + FUTI);
  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_BZ - FUTI);
  glTexCoord2f(0.95f, 0.0f);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_CZ - FUTI);
  glTexCoord2f(0.95f, 0.95f);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_DZ + FUTI);
  glEnd();
  
  setTexture(CARD_TEX_INDEX + num);

  // Gi\j
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f, 0.95f);
  glVertex3f(CARD_DX - FUTI, CARD_DY, CARD_DZ + FUTI);
  glTexCoord2f(0.0f, 0.0f);
  glVertex3f(CARD_CX - FUTI, CARD_CY, CARD_CZ - FUTI);
  glTexCoord2f(0.95f, 0.0f);
  glVertex3f(CARD_BX + FUTI, CARD_BY, CARD_BZ - FUTI);
  glTexCoord2f(0.95f, 0.95f);
  glVertex3f(CARD_AX + FUTI, CARD_AY, CARD_AZ + FUTI);
  glEnd();
  
  glDisable(GL_TEXTURE_2D);

  glDisable(GL_CULL_FACE);
}

