#ifndef __SS_CARD__
#define __SS_CARD__

#define SS_CARD_MAX 64

#define CARD_WIDTH 0.3f
#define CARD_HEIGHT 0.4f

#define CARD_AX -0.15f
#define CARD_BX -0.15f
#define CARD_CX 0.15f
#define CARD_DX 0.15f
	
#define CARD_AY 0.0f
#define CARD_BY 0.0f
#define CARD_CY 0.0f
#define CARD_DY 0.0f
	
#define CARD_AZ -0.2f
#define CARD_BZ 0.2f
#define CARD_CZ 0.2f
#define CARD_DZ -0.2f

#define FUTI 0.013f

#ifdef SS_CARD_ITSELF
#define SS_CARD_EXT

static int g_card;
static int state_table[SS_CARD_MAX];
static int state_visible[SS_CARD_MAX];
static float state_rotate[SS_CARD_MAX];

#else
#define SS_CARD_EXT extern
#endif

#define STATE_CLOSE 0
#define STATE_OPEN  1
#define STATE_SPACE 2

SS_CARD_EXT int initCard(int num);
SS_CARD_EXT int openCard(int index);
SS_CARD_EXT int getCardNum(int index);
SS_CARD_EXT int getCardState(int index);
SS_CARD_EXT int getRandomCard();
SS_CARD_EXT int takeCard(int index);
SS_CARD_EXT int closeCard(int index);
SS_CARD_EXT void deinitCard();
SS_CARD_EXT void loopCard();
SS_CARD_EXT void paintCard(int index, int num);

#endif
