#include <windows.h>
#include <stdio.h>

#define SS_SEFFECT_ITSELF

#include "ss_seffect.h"

int swapW(int w){
  int n = 0;
  short a = 1;
  if(*(char *)&a == 1){
    return w;
  }
  else{
    n += (w >> 24) & 0x000000FF;
    n += (w >> 8) & 0x0000FF00;
    n += (w << 8) & 0x00FF0000;
    n += (w << 24) & 0xFF000000;
    return n;
  }
}

int initSEffect(){
  hWOut = NULL;

  wf.wFormatTag = WAVE_FORMAT_PCM;
  wf.nChannels = 2;   // Stereo
  wf.nSamplesPerSec = 44100;  // 44100 Hz
  wf.nAvgBytesPerSec = 44100 * 2 * 2; // 44100 Hz * 16 bits * Stereo
  wf.nBlockAlign = 2 * 2;   // 16 bits * Mono
  wf.wBitsPerSample = 16;   // 16 bits
  wf.cbSize = 0;

  wh.lpData = NULL; // Pointer of Wave Data
  wh.dwBufferLength = 0; // Buffer Size
  wh.dwBytesRecorded = 0;
  wh.dwUser = 0;
  wh.dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
  wh.dwLoops = 1;
  wh.lpNext = NULL;
  wh.reserved = 0;

  if(waveOutOpen(&hWOut, WAVE_MAPPER, &wf, (DWORD)NULL, 0, CALLBACK_NULL) != MMSYSERR_NOERROR){
    hWOut = NULL;
  }

  pwave = NULL;
  wave_size = 0;

  return 1;
}

int readSEffect(char *filename){
  long file_size;
  FILE *fp;

  if(hWOut == NULL){
    return 0;
  }

  if(pwave != NULL){
    free(pwave);
    pwave = NULL;
  }

  if((fp = fopen(filename, "rb")) == NULL){
    return 0;
  }

  fread(&file_size, sizeof(long), 1, fp);

  wave_size = swapW(file_size);

  if((pwave = (char *)malloc(file_size)) == NULL){
    fclose(fp);
    return 0;
  }

  fread(pwave, file_size, 1, fp);

  wh.lpData = pwave; // Pointer of Wave Data
  wh.dwBufferLength = wave_size; // Buffer Size

  waveOutPrepareHeader(hWOut, &wh, sizeof(WAVEHDR));

  fclose(fp);

  return 1;
}

void playSEffect(){

  if(hWOut == NULL){
    return;
  }

  waveOutReset(hWOut);

  waveOutWrite(hWOut,&wh,sizeof(WAVEHDR));
}

void deinitSEffect(){

  waveOutPause(hWOut);
  waveOutReset(hWOut);

  waveOutUnprepareHeader(hWOut, &wh, sizeof(WAVEHDR));

  if(pwave != NULL){
    free(pwave);
    pwave = NULL;
  }

  waveOutClose(hWOut);

  hWOut = NULL;
}
