#include <windows.h>
#include <stdio.h>
#include <process.h>

#define SS_SOUND_ITSELF

#include "ss_sound.h"

int swapW(int w){
  int n = 0;
  short a = 1;
  if(*(char *)&a == 1){
    return w;
  }
  else{
    n += (w >> 24) & 0x000000FF;
    n += (w >> 8) & 0x0000FF00;
    n += (w << 8) & 0x00FF0000;
    n += (w << 24) & 0xFF000000;
    return n;
  }
}

void get_buf(char *buf, int size){
  static int p = 0;

  if(p + size < filesize){
    fread(buf, size, 1, fp);
    p += size;
  }
  else{
    fread(buf, (filesize - p), 1, fp);
    fseek(fp, 4L, SEEK_SET);
    fread(&buf[filesize - p], (size - filesize + p), 1, fp);
    p += size - filesize;
  }
}

// SoundThread
void SoundThread(void *data){
  PDATA pData;
  pData = (PDATA)data;

  static BOOL th_flag = FALSE;
  static int num = 0;

  if(!th_flag){
    th_flag = TRUE;
    while (!pData->thread_end){
      WaitForSingleObject(hMutex, 300);
      if(pData->done == 1){
        get_buf(buffer[num % 2], SOUND_BUFFER_SIZE);
        waveOutWrite(hWOut, &wh[num % 2], sizeof(WAVEHDR));
        num++;
        pData->done = 0;
      }
      ReleaseMutex(hMutex);
    }
    th_flag = FALSE;
  }

  _endthread();

  return;
}

/*
*   v`ud̃R[obN
*   ̒ wave` Ŏn܂֐Ȃ
*/
void CALLBACK waveProc(HWAVEOUT, UINT msg, DWORD, DWORD, DWORD){
  switch(msg){
    case MM_WOM_OPEN:
    case MM_WOM_CLOSE:
      break;
    case MM_WOM_DONE:
      WaitForSingleObject(hMutex, INFINITE);
      if(data1.done == 0){
        data1.done = 1;
      }
      ReleaseMutex(hMutex);
      break;
    default:
      break;
  }
}

int initSound(char *filename){
  int i;

  hMutex = CreateMutex(NULL, FALSE, MUTEX_STRING);

  if(!hMutex || (GetLastError() == ERROR_ALREADY_EXISTS)){
    return 0;
  }

  if((fp = fopen(filename, "rb")) == NULL){
    return 0;
  }

  fread(&filesize, sizeof(long), 1, fp);

  filesize = swapW(filesize);

  hWOut = NULL;

  wf.wFormatTag = WAVE_FORMAT_PCM;
  wf.nChannels = CHANNELS;
  wf.nSamplesPerSec = SAMPLE_RATE;
  wf.nAvgBytesPerSec = SAMPLE_RATE * (SOUND_BITS >> 3) * CHANNELS;
  wf.nBlockAlign = (SOUND_BITS >> 3) * CHANNELS;
  wf.wBitsPerSample = SOUND_BITS;
  wf.cbSize = 0;

  if(waveOutOpen(&hWOut, WAVE_MAPPER, &wf, (DWORD)(void*)waveProc, 0, CALLBACK_FUNCTION) != MMSYSERR_NOERROR){
    return 0;
  }

  for(i = 0; i < 2; i++){
    wh[i].lpData = buffer[i];
    wh[i].dwBufferLength = SOUND_BUFFER_SIZE;
    wh[i].dwBytesRecorded = 0;
    wh[i].dwUser = 0;
    wh[i].dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
    wh[i].dwLoops = 1;
    wh[i].lpNext = NULL;
    wh[i].reserved = 0;

    get_buf(buffer[i], SOUND_BUFFER_SIZE);

    if(waveOutPrepareHeader(hWOut, &wh[i], sizeof(WAVEHDR)) != MMSYSERR_NOERROR){
      return 0;
    }
  }

  return 1;
}

void playSound(){
  int i;

  data1.done = 0;
  data1.thread_end = FALSE;

  _beginthread(SoundThread, 0, &data1);

  for(i = 0; i < 2; i++){
    waveOutWrite(hWOut, &wh[i], sizeof(WAVEHDR));
  }
}

void deinitSound(){
  int i;

  data1.thread_end = TRUE;

  waveOutPause(hWOut);
  waveOutReset(hWOut);

  for(i = 0; i < 2; i++){
    waveOutUnprepareHeader(hWOut , &wh[i] , sizeof(WAVEHDR));
  }

  waveOutClose(hWOut);

  CloseHandle(hMutex);

  fclose(fp);
}
