#include <windows.h>
#include <GL/gl.h>
#include "r_nm3.h"

#define SS_SYOUHAI_ITSELF

#include "ss_syouhai.h"

void initSyouhai(){
  kati[0] = read_nm3("nm3\\k1.nm3");
  kati[1] = read_nm3("nm3\\k2.nm3");
  kati[2] = read_nm3("nm3\\k3.nm3");
  kati[3] = read_nm3("nm3\\k4.nm3");
  kati[4] = read_nm3("nm3\\k5.nm3");
  kati[5] = read_nm3("nm3\\k6.nm3");
  kati[6] = read_nm3("nm3\\k7.nm3");
  kati[7] = read_nm3("nm3\\k8.nm3");
  kati[8] = read_nm3("nm3\\k9.nm3");
  kati[9] = read_nm3("nm3\\k10.nm3");
  kati[10] = read_nm3("nm3\\k11.nm3");

  hiki[0] = read_nm3("nm3\\h1.nm3");
  hiki[1] = read_nm3("nm3\\h2.nm3");
  hiki[2] = read_nm3("nm3\\h3.nm3");
  hiki[3] = read_nm3("nm3\\h4.nm3");
  hiki[4] = read_nm3("nm3\\h5.nm3");
  hiki[5] = read_nm3("nm3\\h6.nm3");
  hiki[6] = read_nm3("nm3\\h7.nm3");
  hiki[7] = read_nm3("nm3\\h8.nm3");

  make[0] = read_nm3("nm3\\m1.nm3");
  make[1] = read_nm3("nm3\\m2.nm3");
  make[2] = read_nm3("nm3\\m3.nm3");
  make[3] = read_nm3("nm3\\m4.nm3");
  make[4] = read_nm3("nm3\\m5.nm3");
  make[5] = read_nm3("nm3\\m6.nm3");
  make[6] = read_nm3("nm3\\m7.nm3");
}

void deinitSyouhai(){
  int i;

  for(i = 0; i < 11; i++){
    free_nm3(kati[i]);
  }

  for(i = 0; i < 8; i++){
    free_nm3(hiki[i]);
  }

  for(i = 0; i < 7; i++){
    free_nm3(make[i]);
  }
}

void kati_paint(){
  glBegin(GL_TRIANGLES);
  for(int k = 0; k < 11; k++) {
    for(int j = 0; j < kati[k]->face; j++) {
      for(int i = 0; i < 3; i++){
        int vn = kati[k]->data_face[j * 3 + i];
        GLfloat *vert[3];
        vert[0] = &(kati[k]->data_vertex[vn * 3]);
        glVertex3fv(vert[0]);
      }
    }
  }
  glEnd();
}

void hiki_paint(){
  glBegin(GL_TRIANGLES);
  for(int k = 0; k < 8; k++) {
    for(int j = 0; j < hiki[k]->face; j++) {
      for(int i = 0; i < 3; i++){
        int vn = hiki[k]->data_face[j * 3 + i];
        GLfloat *vert[3];
        vert[0] = &(hiki[k]->data_vertex[vn * 3]);
        glVertex3fv(vert[0]);
      }
    }
  }
  glEnd();
}

void make_paint(){
  glBegin(GL_TRIANGLES);
  for(int k = 0; k < 7; k++) {
    for(int j = 0; j < make[k]->face; j++) {
      for(int i = 0; i < 3; i++){
        int vn = make[k]->data_face[j * 3 + i];
        GLfloat *vert[3];
        vert[0] = &(make[k]->data_vertex[vn * 3]);
        glVertex3fv(vert[0]);
      }
    }
  }
  glEnd();
}

void paintSyouhai(int p){
  glLoadIdentity();

  switch(p){
    case 1:
      glTranslated(-0.21, 0.11, -2.0);

      glColor3d(1.0, 0.2, 0.2);

      kati_paint();

      glTranslated(0.001, 0.0, 0.0);

      kati_paint();
 
      break;
    case 2:
      glTranslated(-0.4, 0.11, -2.0);

      glColor3d(0.2, 1.0, 0.2);

      hiki_paint();

      glTranslated(0.001, 0.0, 0.0);

      hiki_paint();

      break;
    case 3:
      glTranslated(-0.2, 0.11, -2.0);

      glColor3d(0.2, 0.2, 1.0);

      make_paint();

      glTranslated(0.001, 0.0, 0.0);

      make_paint();

      break;
  }
}
