#include <windows.h>
#include <GL/gl.h>
#include "r_nm3.h"

#define SS_TOKUTEN_ITSELF

#include "ss_tokuten.h"

void initTokuten(){
  player[0] = read_nm3("nm3\\p1.nm3");
  player[1] = read_nm3("nm3\\p2.nm3");
  player[2] = read_nm3("nm3\\p3.nm3");
  player[3] = read_nm3("nm3\\p4.nm3");
  player[4] = read_nm3("nm3\\p5.nm3");
  player[5] = read_nm3("nm3\\p6.nm3");

  computer[0] = read_nm3("nm3\\c1.nm3");
  computer[1] = read_nm3("nm3\\c21.nm3");
  computer[2] = read_nm3("nm3\\c22.nm3");
  computer[3] = read_nm3("nm3\\c3.nm3");
  computer[4] = read_nm3("nm3\\c4.nm3");
  computer[5] = read_nm3("nm3\\c5.nm3");
  computer[6] = read_nm3("nm3\\c6.nm3");
  computer[7] = read_nm3("nm3\\c7.nm3");
  computer[8] = read_nm3("nm3\\c8.nm3");

  num[0] = read_nm3("nm3\\n01.nm3");
  num[1] = read_nm3("nm3\\n02.nm3");
  num[2] = read_nm3("nm3\\n1.nm3");
  num[3] = read_nm3("nm3\\n2.nm3");
  num[4] = read_nm3("nm3\\n3.nm3");
  num[5] = read_nm3("nm3\\n4.nm3");
  num[6] = read_nm3("nm3\\n5.nm3");
  num[7] = read_nm3("nm3\\n6.nm3");
  num[8] = read_nm3("nm3\\n7.nm3");
  num[9] = read_nm3("nm3\\n81.nm3");
  num[10] = read_nm3("nm3\\n82.nm3");
  num[11] = read_nm3("nm3\\n9.nm3");
}

void deinitTokuten(){
  int i;

  for(i = 0; i < 6; i++){
    free_nm3(player[i]);
  }

  for(i = 0; i < 9; i++){
    free_nm3(computer[i]);
  }

  for(i = 0; i < 12; i++){
    free_nm3(num[i]);
  }

}

void num_paint(int n){
  int i, j , vn;

  glBegin(GL_TRIANGLES);

  switch(n){
    case 0:
      for (j = 0; j < num[0]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[0]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[0]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      for (j = 0; j < num[1]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[1]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[1]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 1:
      for (j = 0; j < num[2]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[2]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[2]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 2:
      for (j = 0; j < num[3]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[3]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[3]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 3:
      for (j = 0; j < num[4]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[4]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[4]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 4:
      for (j = 0; j < num[5]->face; j++) {
        for(int i = 0; i < 3; i++){
          vn = num[5]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[5]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 5:
      for (j = 0; j < num[6]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[6]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[6]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 6:
      for (j = 0; j < num[7]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[7]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[7]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 7:
      for (j = 0; j < num[8]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[8]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[8]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 8:
      for (j = 0; j < num[9]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[9]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[9]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      for (j = 0; j < num[10]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[10]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[10]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
    case 9:
      for (j = 0; j < num[11]->face; j++) {
        for(i = 0; i < 3; i++){
          vn = num[11]->data_face[j * 3 + i];
          GLfloat *vert[3];
          vert[0] = &(num[11]->data_vertex[vn * 3]);
          glVertex3fv(vert[0]);
        }
      }
      break;
  }
  glEnd();
}

void player_paint(){
  int i, j, k, vn;
  glBegin(GL_TRIANGLES);

  for(k = 0; k < 6; k++) {
    for(j = 0; j < player[k]->face; j++) {
      GLfloat *norm[3];
      norm[0] = &(player[k]->data_normal[j * 3]);
      //glNormal3fv(norm[0]);
      for(i = 0; i < 3; i++){
        vn = player[k]->data_face[j * 3 + i];
        GLfloat *vert[3];
        vert[0] = &(player[k]->data_vertex[vn * 3]);
        glVertex3fv(vert[0]);
      }
    }
  }
  glEnd();
}

void computer_paint(){
  int i, j, k, vn;
  glBegin(GL_TRIANGLES);

  for(k = 0; k < 9; k++) {
    for(j = 0; j < computer[k]->face; j++) {
      GLfloat *norm[3];
      norm[0] = &(computer[k]->data_normal[j * 3]);
      //glNormal3fv(norm[0]);
      for(i = 0; i < 3; i++){
        vn = computer[k]->data_face[j * 3 + i];
        GLfloat *vert[3];
        vert[0] = &(computer[k]->data_vertex[vn * 3]);
        glVertex3fv(vert[0]);
      }
    }
  }
  glEnd();
}

void paintTokuten(int p, int c){
  int p_first, p_second;
  int c_first, c_second;

  p_first = p / 10;
  p_second = p % 10;

  c_first = c / 10;
  c_second = c % 10;

  glLoadIdentity();

  glTranslated(-1.37, 0.97, -2.0);

  glColor3d(1.0, 0.3, 0.3);

  player_paint();

  glTranslated(0.001, 0.0, 0.0);

  player_paint();

  glTranslated(0.35, 0.01, 0.0);

  num_paint(p_first);

  glTranslated(0.001, 0.0, 0.0);

  num_paint(p_first);

  glTranslated(0.08, 0.0, 0.0);

  num_paint(p_second);

  glTranslated(0.001, 0.0, 0.0);

  num_paint(p_second);

  glColor3d(0.3, 0.3, 1.0);

  glTranslated(0.15, -0.01, 0.0);

  computer_paint();

  glTranslated(0.001, 0.0, 0.0);

  computer_paint();

  glTranslated(0.52, 0.01, 0.0);

  num_paint(c_first);

  glTranslated(0.001, 0.0, 0.0);

  num_paint(c_first);

  glTranslated(0.08, 0.0, 0.0);

  num_paint(c_second);

  glTranslated(0.001, 0.0, 0.0);

  num_paint(c_second);
}
